mod Ex02a logic: 'cl'

loc rem 
  \para \bf  2. CVICENIE Z PREDMETU 1-AIN-470 SPECIFIKACIA A VERIFIKACIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end stvrtok 19.2.2009 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/0809ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane vyrokovo-logickemu 
  vyplyvaniu a logike s kvantifikatormi. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subory \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subory \it  mlogic*.cl  \end obsahuju popis verifikacneho systemu 
         CL. 
   \item \para Subory \it  ex*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Propositional Logic.  \end 

rem 
  \para \bf  Section. Tableaux with Axioms.  \end 

rem 
  \para \bf  [CL] Remark.  \end The module \it  Mlogicpx  \end in the file \it  
  mlogicpx.cl  \end contains the syntax of tableau rules for propositional 
  tableaux with axioms. The module \it  Mlogicd  \end in the file \it  
  mlogicd.cl  \end contains the syntax of derived tableau rules. 

rem 
  \para \bf  Remark.  \end The following exercises are logical problems from the 
  book \it  What is the name of this book?  \end by Raymond Smullyan . The 
  problems are from the cases solved by the famous inspector Nick Fishthrawn of 
  Scotland Yard. 

theory Sm72 logic: 'prop_def'

fun/0 X 

fun/0 Y 

fun/0 Z 

pred G 

rem 
  \para \bf  Exercise.  \end Investigation by inspector Fishtrawn brought up the 
  following facts: 
  \items 
   \item \para \it  (1)  \end The robbery was done by at most by \ft X \end, 
         \ft Y \end, or \ft Z \end. 
   \item \para \it  (2)  \end \ft X \end always works with a companion. 
   \item \para \it  (3)  \end \ft Z \end is not guilty. 
  \end
  \para Problem: Is \ft Y \end guilty? 
  \para \it  Formalization.  \end 
  \items 
   \item \para The constants \ft X \end, \ft Y \end a \ft Z \end represent the 
         suspects. 
   \item \para The predicate \ft G(x) \end holds if \ft x \end is guilty. 
  \end
  \para The axioms \it  A1  \end, \it  A2  \end a \it  A3  \end arithmetize the 
  facts \it  (1)  \end, \it  (2)  \end a \it  (3)  \end. Our goal is to prove 
  that the claim \ft G(Y) \end is a tautological consequence of these axioms. 

axiom A1
  G(X) \/ G(Y) \/ G(Z)

axiom A2
  G(X) -> G(Y) \/ G(Z)

axiom A3
  ~G(Z)

thm Gy
  G(Y)

end theory Sm72

theory Sm74 logic: 'prop_def'

fun/0 X 

fun/0 Y 

fun/0 Z 

pred G 

loc rem 
  \para \bf  Exercise.  \end What are the consequences of the following facts? 
  \items 
   \item \para \it  (1)  \end If \ft X \end is guilty and \ft Y \end is not then 
         \ft Z \end is guilty. 
   \item \para \it  (2)  \end \ft Z \end never works alone. 
   \item \para \it  (3)  \end \ft X \end never works with \ft Z \end. 
   \item \para \it  (4)  \end Except \ft X \end, \ft Y \end, or \ft Z \end 
         nobody else is involved in the case. 
  \end
  \para Decide the guiltiness of each person involved, i.e. prove whether G(x) 
  or \ft ~G(x) \end for every \ft x = X,Y,Z \end. 

axiom A1
  G(X) & ~G(Y) -> G(Z)

axiom A2
  G(Z) -> G(X) \/ G(Y)

axiom A3
  ~(G(X) & G(Z))

axiom A4
  G(X) \/ G(Y) \/ G(Z)

end theory Sm74

theory Sm75 logic: 'prop_def'

fun/0 X 

fun/0 Y 

fun/0 Z 

pred G 

loc rem 
  \para \bf  Exercise.  \end The merchant McGregor was robbed. There were three 
  suspects \ft X \end, \ft Y \end, and \ft Z \end. The following facts were 
  unearthed: 
  \items 
   \item \para \it  (1)  \end All suspects and nobody else was that day in 
         McGregor's store. 
   \item \para \it  (2)  \end If \ft X \end is guilty then he worked with a 
         companion. 
   \item \para \it  (3)  \end If \ft Y \end is not guilty, neither is 
         \ft Z \end. 
   \item \para \it  (4)  \end If exactly two are guilty then \ft X \end is among 
         them. 
   \item \para \it  (5)  \end If \ft Z \end is not guilty then neither is 
         \ft Y \end. 
  \end
  \para Decide the guiltiness of each person involved. 

axiom A1
  G(X) \/ G(Y) \/ G(Z)

axiom A2
  G(X) -> G(Y) \/ G(Z)

axiom A3
  ~G(Y) -> ~G(Z)

axiom A4
  ~(G(Y) & G(Z) & ~G(X))

axiom A5
  ~G(Z) -> ~G(Y)

end theory Sm75

theory Sm81 logic: 'prop_def'

fun/0 X 

fun/0 Y 

fun/0 Z 

fun/0 W 

pred G 

rem 
  \para \bf  Exercise.  \end In a police case the following was found out: 
  \items 
   \item \para \it  (1)  \end If \ft X \end is guilty then \ft Y \end was his 
         companion. 
   \item \para \it  (2)  \end If \ft Y \end is guilty then either \ft X \end is 
         not or \ft Z \end is guilty. 
   \item \para \it  (3)  \end If \ft W \end is not guilty then \ft X \end is and 
         \ft Z \end is not. 
   \item \para \it  (4)  \end If \ft W \end is guilty then so is \ft X \end. 
  \end
  \para Decide the guiltiness of each person involved. 

axiom A1
  G(X) -> G(Y)

axiom A2
  G(Y) -> G(Z) \/ ~G(X)

axiom A3
  ~G(W) -> G(X) & ~G(Z)

axiom A4
  G(W) -> G(X)

end theory Sm81

