mod Ex02b logic: 'cl'

loc rem 
  \para \bf  2. CVICENIE Z PREDMETU 1-AIN-470 SPECIFIKACIA A VERIFIKACIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end stvrtok 19.2.2009 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/0809ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane vyrokovo-logickemu 
  vyplyvaniu a logike s kvantifikatormi. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subory \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subory \it  mlogic*.cl  \end obsahuju popis verifikacneho systemu 
         CL. 
   \item \para Subory \it  ex*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Quantification Logic.  \end 

rem 
  \para \bf  Section. Quantification Tableaux.  \end 

rem 
  \para \bf  [CL] Remark.  \end The module \it  Mlogicpx  \end in the file \it  
  mlogicpx.cl  \end contains the syntax of tableau rules for propositional 
  tableaux with axioms. The module \it  Mlogicd  \end in the file \it  
  mlogicd.cl  \end contains the syntax of derived tableau rules. 

theory Examples logic: 'fol_yeq_min'

pred/2 R 

rem 
  \para \bf  Exercise.  \end Prove the following sentence: 
  \eq* 
    \e y\a xR(x,y) -> \a x\e yR(x,y)
  \end

thm Exists_forall
  \e y\a xR(x,y) -> \a x\e yR(x,y)

pred A 

pred B 

rem 
  \para \bf  Exercise.  \end Prove the following sentences: 
  \eq* 
    \e x(A(x) & B(x)) -> \e xA(x) & \e xB(x)
  \end
  \eq* 
    \a xA(x) \/ \a xB(x) -> \a x(A(x) \/ B(x))
  \end
  \eq* 
    ~\e xA(x) <-> \a x~A(x)
  \end

thm Exists_and
  \e x(A(x) & B(x)) -> \e xA(x) & \e xB(x)

thm Forall_or
  \a xA(x) \/ \a xB(x) -> \a x(A(x) \/ B(x))

thm Not_exists
  ~\e xA(x) <-> \a x~A(x)

end theory Examples

rem 
  \para \bf  [CL] Remark.  \end In the following examples you can use derived 
  quantifier tableau rules as described in the module \it  Mlogicd  \end (see 
  the file \it  mlogicd.cl  \end). 

theory Sm_reflexivity logic: 'fol_def'

pred/2 A 

rem 
  \para \bf  Exercise.  \end Suppose that the binary relation \ft A(x,y) \end is 
  symmetric and transitive: 

axiom Symmetry
  \a x\a y(A(x,y) -> A(y,x))

axiom Transitivity
  \a x\a y\a z(A(x,y) & A(y,z) -> A(x,z))

rem 
  \para Show that the relation is reflexive on its domain of definition: 

thm Reflexivity
  \a x\a y(A(x,y) -> A(x,x))

end theory Sm_reflexivity

theory Sm_quine logic: 'fol_def'

pred A 

pred B 

pred C 

rem 
  \para \bf  Exercise.  \end Suppose that we have 

axiom Ax1
  \a x(A(x) & B(x) -> C(x)) -> \e x(A(x) & ~B(x))

axiom Ax2
  \a x(A(x) -> B(x)) \/ \a x(A(x) -> C(x))

axiom Ax3
  \a x(A(x) & C(x) -> B(x))

rem 
  \para Prove the following claim: 

thm Theorem
  \e x(A(x) & B(x) & ~C(x))

end theory Sm_quine

